unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Character, ExtCtrls, ComCtrls, World, Buttons;


type
  TForm1 = class(TForm)
    Tm: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Sh: TImage;
    PcRunL: TImage;
    PcRunR: TImage;
    PcStandL: TImage;
    PcStandR: TImage;
    PcJumpL: TImage;
    PcJumpR: TImage;
    PcFallL: TImage;
    PcFallR: TImage;
    Label5: TLabel;
    Label6: TLabel;
    SpeedButton1: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure TmTimer(Sender: TObject);
    procedure BtClick(Sender: TObject);
  private
    procedure ShowParameters;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Ch: TCharacter;
  Wr: TWorld;
  MaxH: Extended;
  FrameCount: Integer;
  FrameSwitch: Integer;
  PriorFrame: Boolean;

implementation

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
begin
  Form1.BorderStyle := bsNone;
  Form1.WindowState := wsMaximized;
  Wr := TWorld.Create;
  if not Wr.LoadMap(ExtractFilePath(Application.ExeName) + 'level') then
    Exit;
  Ch := TCharacter.Create(Wr, 46 - 18, 60 - 12, 100, 600);
  ShowMessage('Left, Right, Up (Ctrl za trcanje)!' + #10#13);
  Application.ProcessMessages;
  Sh.Picture.Assign(PcStandR.Picture);
  Tm.Enabled := True;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_LEFT then
    Ch.GoLeft;
  if Key = VK_RIGHT then
    Ch.GoRight;
  if Key = VK_UP then
    Ch.GoJump;
  if Key = VK_CONTROL then
    Ch.GoRun;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_LEFT then
    Ch.StopLeft;
  if Key = VK_RIGHT then
    Ch.StopRight;
  if Key = VK_UP then
    Ch.StopJump;
  if Key = VK_CONTROL then
    Ch.StopRun;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
end;

procedure TForm1.TmTimer(Sender: TObject);
begin
  Sh.Left := Ch.GetX - 9;
  Sh.Top := Form1.ClientHeight - Sh.Height - Ch.GetY + 6;
  Ch.Tick;
  if flgRunning in Ch.Flags then
    FrameSwitch := 5
  else
    FrameSwitch := 8;

  if flgGround in Ch.Flags then
    if flgJumping in Ch.Flags then
    begin
      Sh.Picture.Assign(TImage(Form1.FindComponent('PcJump' + Ch.Orient)).Picture)
    end
    else
    if flgFalling in Ch.Flags then
    begin
      if PriorFrame then
        Sh.Picture.Assign(TImage(Form1.FindComponent('PcFall' + Ch.Orient)).Picture)
      else
        Sh.Picture.Assign(TImage(Form1.FindComponent('PcFall' + Ch.Orient)).Picture);
      Inc(FrameCount);
      if FrameCount >= FrameSwitch then
      begin
        PriorFrame := not PriorFrame;
        FrameCount := 0;
      end;
    end
    else
    if not ((flgGoingLeft in Ch.Flags) or (flgGoingRight in Ch.Flags)) then
      Sh.Picture.Assign(TImage(Form1.FindComponent('PcStand' + Ch.Orient)).Picture)
    else
    begin
      if PriorFrame then
        Sh.Picture.Assign(TImage(Form1.FindComponent('PcRun' + Ch.Orient)).Picture)
      else
        Sh.Picture.Assign(TImage(Form1.FindComponent('PcStand' + Ch.Orient)).Picture);
      Inc(FrameCount);
      if FrameCount >= FrameSwitch then
      begin
        PriorFrame := not PriorFrame;
        FrameCount := 0;
      end;
    end
  else
  if (flgAir in Ch.Flags) or (flgWater in Ch.Flags) then
  begin
    if PriorFrame then
      Sh.Picture.Assign(TImage(Form1.FindComponent('PcFall' + Ch.Orient)).Picture)
    else
      Sh.Picture.Assign(TImage(Form1.FindComponent('PcRun' + Ch.Orient)).Picture);
    Inc(FrameCount);
    if flgJumping in Ch.Flags then
      FrameSwitch := 2
    else
      FrameSwitch := 12;
    if FrameCount >= FrameSwitch then
    begin
      PriorFrame := not PriorFrame;
      FrameCount := 0;
    end;
  end;
  ShowParameters;
end;

procedure TForm1.ShowParameters;
begin
  Label1.Caption := 'X   = ' + FormatFloat(',000.0000', Ch.X);
  Label2.Caption := 'Y   = ' + FormatFloat(',000.0000', Ch.Y);
  Label3.Caption := 'Vx  = ' + FormatFloat(',000.0000', Ch.Vx);
  Label4.Caption := 'Vy  = ' + FormatFloat(',000.0000', Ch.Vy);
  Label5.Caption := 'PrX  = ' + FormatFloat(',000.0000', Ch.PriorX);
  Label6.Caption := 'PrY  = ' + FormatFloat(',000.0000', Ch.PriorY);
  Label8.Visible := flgFalling in Ch.Flags;
  Label9.Visible := flgJumping in Ch.Flags;
end;
procedure TForm1.BtClick(Sender: TObject);
var
  F: file of TLevelData;
  T: TLevelData;
begin
  AssignFile(F, 'c:\level.lvm');
  Rewrite(F, 'c:\level.lvm');
  T.WidthTiles := 16;
  T.HeightTiles := 12; //1024*768
  T.TLRFile := 'level.tlr';
  Write(F, T);
  CloseFile(F);  
end;

end.
